SystemOrganization addCategory: #Chess!

Object subclass: #GPicture
	instanceVariableNames: 'pic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:16'!
dibujar: p
	| img n i |
	img := pic img.
	n := img size.
	i :=0.
	[ i < n ] whileTrue: [ self parseLine: i cad: ( img at: ( n - 1 - i ) ) ]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:29'!
parseChar: c
	| color |
	( c = '_' ) ifTrue: [ color := Color lightGray. ^color ]
	ifFalse: [ ( c='=' ) ifTrue: [ color := Color gray.	^color ] 
			ifFalse: [ ( c='.' ) ifTrue: [ color := Color white. ^color ] 
				ifFalse: [ ( c='@' ) ifTrue: [ color := Color black. ^color ] 
					ifFalse: [ ( c='#' ) ifTrue: [color := Color darkGray. ^color ]
						ifFalse: [ color := Color blue. ^color ] ]]]]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:19'!
parseLine: y cad: s
	s size = 0 ifFalse: [
		| xi xf c |
		xi := 0.
		xf := 1.
		c := s at: xi.
		[ xf < s size] whileTrue: [ 
			( c = ' ' & c !!= s at: xf ) ifTrue: [c := s at: xf. xi := xf]
				ifFalse: [ ( c !!= s at: xf ) ifTrue: [ 
						self parseChar: c. 
						"dibujar una linea desde (xi,y) to (xf,y)." 
						c := s at: xf. 
						xi := xf] ].
				xf := xf + 1.
			].
		( c !!= ' ' ) ifTrue: [ self parseChar: c. "dibujar una linea desde (xi,y) to (xf,y)."  ]
	]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/14/2012 00:06'!
pic: p
	pic := p! !

Object subclass: #Picture
	instanceVariableNames: 'img height width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!Picture methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 10/13/2012 21:56'!
espejoV
	| pic i n |
	img := pic img .
	i := 0.
	n := img width .
	[i < n] whileTrue: [|s ns| i := i+1. s := pic img at: i. ns := ''. ]! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:10'!
height
	^height! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:11'!
height: alto
	height := alto! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:12'!
img
	^img! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:10'!
img: imagen
	img := imagen
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:16'!
initialize
	super initialize.
	self height:0.
	self width:0
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:20'!
invColor: color1
	|c|

	(color1= '_') ifTrue:  [c:= '='] .
	(color1= '=') ifTrue:  [c:= '_'].
	(color1= '.') ifTrue:  [c:= '@'].
	(color1= '@') ifTrue:  [c:= '.'].
	 ^ c ! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:10'!
width
	^width! !

!Picture methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:12'!
width: ancho
	width := ancho! !

TestCase subclass: #Test
	instanceVariableNames: 'picture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chess'!

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 16:03'!
setUp
	|body p|
	body := #('#.. ','##= ','###@ ',' ###').
	p := Picture new.
	p img:body! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testAlLado
	|body p|
	body:= #('#.. #.. ', '##= ##= ', '###@###@','  ### ###').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testEncima
	|body p pn|
	body:= #('#.. ', '##= ', '###@','  ###', '#@@ ', '##_ ', '###. ', ' ###').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testEspejoH
	|body p|
	body:= #(' ###','###@','##= ','#.. ').
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testEspejoV
	|body p|
	body:= #(' ..# ',' =## ','@###',' ### ').
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 15:35'!
testInit
	self assert:picture width=4.
	self assert:picture height=4
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:09'!
testNegativo
	|body |
	body:= #('#@@ ','##_  ','@###.',' ### ').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:09'!
testRepetirH
	|body|
	body:= #('#.. #.. #.. ', '##= ##= ##= ', '###@###@###@',' ### ### ###').
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:09'!
testRepetirV
	|body |
	body:= #(' ..# ',' =## ','@###',' ### ',' ..# ',' =## ','@###',' ### ',' ..# ',' =## ','@###',' ### ').
	! !

!Test methodsFor: 'as yet unclassified' stamp: 'Ruth 10/6/2012 17:08'!
testSuperponer
	|body p |
	body:= #('#..#', '##=#', '###@','####').
! !
